#!/usr/bin/perl
use strict;
use warnings;
my $fastafilename=$ARGV[0];
open(DINUCL,"dinucleotide_properties.txt") or die("could not open file\n");
my @file = <DINUCL>;
close(DINUCL);
my $nucl = shift (@file);
chomp $nucl;
my @name_dinucl = split("\t",$nucl);
shift(@name_dinucl);
my %prop_hash;
for(my $i=0;$i<scalar(@file);$i++){
	chomp $file[$i];
	my @prop = split("\t",$file[$i]);
	my $prop_name = shift(@prop);
	for(my $j=0;$j<(scalar(@prop)-1);$j++){
		chomp $prop[$j];
		$prop_hash{$prop_name}{$name_dinucl[$j]}=$prop[$j];
	}
}
my $prop_counter;
pop(@name_dinucl);
my $raw_fasta = $fastafilename;
my $svm_multi_input = $fastafilename."_multi_svm.dat";
my $svm_binary_input = $fastafilename."_bi_svm.dat";
my $rna=0;
open(FINALALL,">",$svm_multi_input) or die("could not open file\n");
my @finalall = ();
	$rna++;
	chomp($raw_fasta);
	my $rnafoldoutfile = $raw_fasta."_rnafold.output";
#change the path of RNAfold if it is placed elsewhere. For version 1.8x change --MEA to -MEA.
	my $command = "RNAfold/bin/RNAfold -p --MEA < ".$raw_fasta." >".$rnafoldoutfile;
	system($command);
	system("rm *.ps");
	open RNAfold,$rnafoldoutfile or die ("could not open a file written by RNAfold.exe\n");
	my @array = <RNAfold>;
	close(RNAfold);
	my $seq_name = $array[0];
	chomp $seq_name;
	print "SEQ NAME:$seq_name\n";
	my $joined_array = ();
	my @singlet = ();
	$joined_array = join("",@array);
	@singlet = split("\>",$joined_array);
	shift(@singlet);
	foreach my $singlet (@singlet){
		my $count_loops = 0; my $fea1=0;my $fea2=0;my $fea3=0;my $fea4=0;my $fea5=0;my $fea6=0;my $fea7=0;my $fea8=0;my $count_star_brac=0;my $count_comma=0;my $value1=0;my $value2=0;my $value3=0,my $value4=0;my $value5=0;my $value6=0;my @array32_trip=();
		chomp $singlet;
		my @sec_properties=();
		push(@sec_properties,$rna);
		my @data = split("\n",$singlet);
		chomp $data[2];
		my $sequence = $data[1];
		chomp $sequence;
		print "SEQUENCE:$sequence\n";
		my $sequence_di_properties = calculate_seq_properties($sequence);
		push(@sec_properties,$sequence_di_properties);
		$prop_counter = 17;
		my $index2 = index($data[3]," ");
		my $line3 = substr($data[3],$index2);
		$line3 =~s/\s|\n|\(|\)|\]|\[//g;
		$line3 = $prop_counter.":".abs($line3);
		push(@sec_properties,$line3);$prop_counter++;
		my $sec2 = substr($data[3],0,$index2);
		while ($sec2 =~ /\{|\}/g) { $count_star_brac++;}
		$count_star_brac = $prop_counter.":".$count_star_brac;$prop_counter++;
		push(@sec_properties,$count_star_brac);
		while ($sec2 =~ /\,/g) { $count_comma++;}
		$count_comma = $prop_counter.":".$count_comma;$prop_counter++;
		push(@sec_properties,$count_comma);
		my $sec3 = $data[4];
		chomp $sec3;
		$sec3 =~s/\.|\)|\(|\s|\n|\{|\}|\-//g;
		$sec3 =~/(\d+)d=(\d+)/g;
		$value1 = $1/100;
		$value1 = $prop_counter.":".$value1;$prop_counter++;
		$value2=$2/100;
		$value2 = $prop_counter.":".$value2;$prop_counter++;
		push(@sec_properties,"$value1 $value2");
		my $sec4 = $data[5];
		chomp $sec4;
		$sec4 =~s/\.|\)|\(|\s|\n|\{|\}|\-//g;
		$sec4 =~/(\d+)MEA=(\d+)/g;
		$value3 = $1/100;
		$value3 = $prop_counter.":".$value3;$prop_counter++;
		$value4 = $2/100;
		$value4 = $prop_counter.":".$value4;$prop_counter++;
		push(@sec_properties,"$value3 $value4");
		my $sec5 = $data[6];
		chomp $sec5;
		$sec5=~/\s+frequency of mfe structure in ensemble (\d+\.\d+)\; ensemble diversity (\d+\.\d+)\s+/g;
		$value5 = $1;
		$value5 = $prop_counter.":".$value5;$prop_counter++;
		$value6 = $2;
		$value6 = $prop_counter.":".$value6;$prop_counter++;
		push(@sec_properties,"$value5 $value6");
		my $mfe_index = index($data[2]," ");
		my $mfe = substr($data[2],$mfe_index);
		$mfe =~s/\s|\n|\(|\)//g;
		print "Minimum Free Energy:$mfe\n";
		$mfe = $prop_counter.":".abs($mfe);$prop_counter++;
		push(@sec_properties,$mfe);
		my $sec1 = substr($data[2],0,$mfe_index);
		chomp $sec1;
		my $open_start_index = 0;my $open_start_a=0;my $open_start_c=0;my $open_start_g=0;my $open_start_u=0;my $open_start=0;
		my $open_stop_index = length($sec1);
		$open_start_index = index($sec1,"\(");
		$open_stop_index = rindex($sec1,"\)");
		for(my $i=1;$i<=$open_start_index;$i++){
			$open_start = substr($sequence,$i,1);
			if($open_start eq "A"){$open_start_a++;}
			if($open_start eq "G"){$open_start_g++;}
			if($open_start eq "C"){$open_start_c++;}
			if($open_start eq "U"){$open_start_u++;}
		}
		my $open_stop_a=0;my $open_stop_c=0;my $open_stop_g=0;my $open_stop_u=0;my $open_stop=0;
		for(my $i=$open_stop_index+1;$i<=length($sec1);$i++){
			$open_stop = substr($sequence,$i,1);
			if($open_stop eq "A"){$open_stop_a++;}
			if($open_stop eq "G"){$open_stop_g++;}
			if($open_stop eq "C"){$open_stop_c++;}
			if($open_stop eq "U"){$open_stop_u++;}
		}		
		while ($sec1 =~ /\(+\.+\)+/g) { $count_loops++;}
		$count_loops = $prop_counter.":".$count_loops;$prop_counter++;
		push(@sec_properties,$count_loops);
		for(my $i=1;$i<=length($sec1)-2;$i++){
		my $triplet = substr($sec1,$i,3);
			if($triplet eq "((("){$fea1++;}
			if($triplet eq "((."){$fea2++;}
			if($triplet eq "(.."){$fea3++;}
			if($triplet eq "..."){$fea4++;}
			if($triplet eq ".(("){$fea5++;}
			if($triplet eq "..("){$fea6++;}
			if($triplet eq ".(."){$fea7++;}
			if($triplet eq "(.("){$fea8++;}
		}
		$fea1 = $prop_counter.":".$fea1;$prop_counter++;
		$fea2 = $prop_counter.":".$fea2;$prop_counter++;
		$fea3 = $prop_counter.":".$fea3;$prop_counter++;
		$fea4 = $prop_counter.":".$fea4;$prop_counter++;
		$fea5 = $prop_counter.":".$fea5;$prop_counter++;
		$fea6 = $prop_counter.":".$fea6;$prop_counter++;
		$fea7 = $prop_counter.":".$fea7;$prop_counter++;
		$fea8 = $prop_counter.":".$fea8;$prop_counter++;
		push(@sec_properties,"$fea1 $fea2 $fea3 $fea4 $fea5 $fea6 $fea7 $fea8");
		@array32_trip = features_miPred($sequence,$sec1);
		my $au = 0;my $cg=0;my $gu=0;my $bulge=0;my $mismatches=0,my $length_of_hairpin=0;my $a_bulge=0;my $g_bulge=0;my $c_bulge=0;my $u_bulge=0;my $a_hair=1;my $u_hair=1;my $c_hair=1;my $g_hair=1;my $string_hair;my $nucl_hair;my $pu_hair=1;my $py_hair=1;		
		foreach my $array32_trip(@array32_trip){chomp $array32_trip;$array32_trip = $prop_counter.":".$array32_trip;$prop_counter++;push(@sec_properties,$array32_trip);}
		my %sec_seq = break_structure($sequence,$sec1);

		while ((my $key, my $value) = each(%sec_seq)){
		
		     my $subseq = $key;
		     my $subsec = $value;
		     $length_of_hairpin = $length_of_hairpin+(index($subsec,"\)")-rindex($subsec,"\("));
		     $string_hair = substr($subseq,rindex($subsec,"\(")+1,index($subsec,"\)")-rindex($subsec,"\(")-1);
		     for(my $i=0;$i<length($string_hair);$i++){
		     	$nucl_hair = substr($string_hair,$i,1);
		     	if($nucl_hair eq "A"){$a_hair++;$pu_hair++;}
		     	if($nucl_hair eq "G"){$g_hair++;$pu_hair++;}
		     	if($nucl_hair eq "U"){$u_hair++;$py_hair++;}
		     	if($nucl_hair eq "C"){$c_hair++;$py_hair++;}
		     	}
		     my $j = length($subsec)-1;
		     for(my $i=0;$i<=$j;$i++){
		     	my $sec_not_1 = substr($subsec,$i,1);
		     	my $sec_not_2 = substr($subsec,$j,1);
		     		if($sec_not_1 eq "\(" && $sec_not_2 eq "\)"){
		     			my $nucl1 = substr($subseq,$i,1);
					my $nucl2 = substr($subseq,$j,1);
					my $dinucl = $nucl1.$nucl2;
						if($dinucl eq "AU" or $dinucl eq "UA"){$au++;}
						elsif($dinucl eq "CG" or $dinucl eq "GC"){$cg++;}
						elsif($dinucl eq "GU" or $dinucl eq "UG"){$gu++;} 
						$j--;
		     		}
		     		elsif($sec_not_1 eq "\(" && $sec_not_2 eq "\."){
					my $nucl_bulge = substr($subseq,$j,1);
						if($nucl_bulge eq "A"){$a_bulge++;}
						elsif($nucl_bulge eq "G"){$g_bulge++;}
						elsif($nucl_bulge eq "C"){$c_bulge++;}
						elsif($nucl_bulge eq "U"){$u_bulge++;}
					$i--;$j--;$bulge++;
				}
				elsif($sec_not_1 eq "\." && $sec_not_2 eq "\)"){
					my $nucl_bulge = substr($subseq,$i,1);
						if($nucl_bulge eq "A"){$a_bulge++;}
						elsif($nucl_bulge eq "G"){$g_bulge++;}
						elsif($nucl_bulge eq "C"){$c_bulge++;}
						elsif($nucl_bulge eq "U"){$u_bulge++;}
					$bulge++;
				}
				elsif($sec_not_1 eq "\." && $sec_not_2 eq "\."){$j--;$mismatches++;}
		     }
		}
		my $count_sec_seq = keys %sec_seq;
		if($count_sec_seq > 0){$length_of_hairpin = abs($length_of_hairpin/$count_sec_seq);}
		$au = $prop_counter.":".$au;$prop_counter++;
		$cg = $prop_counter.":".$cg;$prop_counter++;
		$gu = $prop_counter.":".$gu;$prop_counter++;
		$mismatches = $prop_counter.":".$mismatches;$prop_counter++;
		$bulge = $prop_counter.":".$bulge;$prop_counter++;
		$a_bulge = $prop_counter.":".$a_bulge;$prop_counter++;
		$g_bulge = $prop_counter.":".$g_bulge;$prop_counter++;
		$c_bulge = $prop_counter.":".$c_bulge;$prop_counter++;
		$u_bulge = $prop_counter.":".$u_bulge;$prop_counter++;
		$length_of_hairpin = $prop_counter.":".$length_of_hairpin;$prop_counter++;
		$count_sec_seq = $prop_counter.":".$count_sec_seq;$prop_counter++;
		$a_hair = $prop_counter.":".$a_hair;$prop_counter++;
		$g_hair = $prop_counter.":".$g_hair;$prop_counter++;
		$c_hair = $prop_counter.":".$c_hair;$prop_counter++;
		$u_hair = $prop_counter.":".$u_hair;$prop_counter++;
		$pu_hair = $prop_counter.":".$pu_hair;$prop_counter++;
		$py_hair = $prop_counter.":".$py_hair;$prop_counter++;
		$open_start_a = $prop_counter.":".$open_start_a;$prop_counter++;
		$open_start_g = $prop_counter.":".$open_start_g;$prop_counter++;
		$open_start_c = $prop_counter.":".$open_start_c;$prop_counter++;
		$open_start_u = $prop_counter.":".$open_start_u;$prop_counter++;
		$open_stop_a = $prop_counter.":".$open_stop_a;$prop_counter++;
		$open_stop_g = $prop_counter.":".$open_stop_g;$prop_counter++;
		$open_stop_c = $prop_counter.":".$open_stop_c;$prop_counter++;
		$open_stop_u = $prop_counter.":".$open_stop_u;$prop_counter++;
		push(@sec_properties,"$au $cg $gu $mismatches $bulge $a_bulge $g_bulge $c_bulge $u_bulge $length_of_hairpin $count_sec_seq $a_hair $g_hair $c_hair $u_hair $pu_hair $py_hair $open_start_a $open_start_g $open_start_c $open_start_u $open_stop_a $open_stop_g $open_stop_c $open_stop_u");
		my $all_sec_properties = join(" ",@sec_properties);
		push(@finalall,"$all_sec_properties\n");
	}	
	

print FINALALL @finalall;
close(FINALALL);
my @imp_features=(0,1,2,3,4,5,6,7,8,9,10,11,12,13,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,36,39,43,44,47,50,51,52,53,56,59,60,67,68,69,71,72,73,74,76,77,79,82,83,84,89);
my @imp_features_array=();
my @out_imp_features_array=();
my $imp_features;
open(OLDINPUT,$svm_multi_input) or die("could not open file\n");
open(NEWINPUT,">",$svm_binary_input) or die("could not open file\n");
while(<OLDINPUT>){
	chomp $_;
	my @temp_array = split(" ",$_);
	for $imp_features(@imp_features){
		push(@imp_features_array,$temp_array[$imp_features]);
	}
	my $temp_string = join(" ",@imp_features_array);
	push(@out_imp_features_array,"$temp_string\n");
	@imp_features_array=();
}
print NEWINPUT @out_imp_features_array;
close(NEWINPUT);
close(OLDINPUT);
#change the path libsvm path for svm-scale and svm-predict from libsvm-3.14 to libsvm-3.1x
system("rm ".$rnafoldoutfile);
system("libsvm-3.14/svm-scale -r "."model/binaryclass.range ".$svm_binary_input." >".$svm_binary_input.".scale");
system("rm ".$svm_binary_input);
system("libsvm-3.14/svm-predict ".$svm_binary_input.".scale " ."model/binaryclass-model ".$svm_binary_input.".predict >temp");
system("rm ".$svm_binary_input.".scale");
open(BINPREDICT,$svm_binary_input.".predict") or die("File doesnt exist");
my $bipredict = <BINPREDICT>;
close(BINPREDICT);
chomp $bipredict;
system("libsvm-3.14/svm-scale -r "."model/multiclass.range ".$svm_multi_input." >".$svm_multi_input.".scale");
system("rm ".$svm_multi_input);
#change the path libsvm-errorcode path here.
system("libsvm-errorcode/svm-predict ".$svm_multi_input.".scale " ."model/multiclass-model ".$svm_multi_input.".predict >temp");
system("rm ".$svm_multi_input.".scale");
system("rm temp");
open(MULPREDICT,$svm_multi_input.".predict") or die("File doesnt exist");
my $multipredict = <MULPREDICT>;
close(MULPREDICT);
chomp $multipredict;
my %ptrna = ("1","yes","-1","no");
my %rnafamily=("2","RNaseMRP","3","RNaseP","5","snoRNA","6","snRNA","7","telomeraseRNA","8","YRNA");
$bipredict = $ptrna{$bipredict};
$multipredict = $rnafamily{$multipredict};
print "pTRNA:$bipredict\nRNA Family:$multipredict\n";
system("rm ".$svm_multi_input.".predict");
system("rm ".$svm_binary_input.".predict");


sub break_structure{
my $seq=$_[0];
my $sec=$_[1];
my %sec_seq;
my $start=0;
my $length_forward_br=0;
my $length_backward_br=0;
my $substr_sec;
my $substr_seq;
	for(my $i=0;$i<=length($sec);$i++){
 		my $substruc = substr($sec,$i,1);
		if($substruc eq "\."){next;}
		elsif($substruc eq "\("){
			$length_forward_br++;
			if($length_forward_br == 1){
			$start=$i;
			}
		}elsif($substruc eq "\)"){
			$length_backward_br++;
			if($length_forward_br == $length_backward_br){
				$substr_sec = substr($sec,$start,$i-$start+1);
				$substr_seq = substr($seq,$start,$i-$start+1);
				$sec_seq{$substr_seq}=$substr_sec;
				$start=0;
				$length_forward_br=0;
				$length_backward_br=0;
			}
		}
 	}
	return(%sec_seq);
}


sub calculate_seq_properties{
	my $string = $_[0];
	my $i=0;
	my @temp_array = ();
	foreach my $family ( sort keys %prop_hash ) {
    		$i++;
    		my $tr=0;
    		for my $name_dinucl (@name_dinucl){
    			my @matches=();
			chomp $name_dinucl;
			@matches = $string =~ /($name_dinucl)/g;
			my $count = @matches;
			$tr = ($prop_hash{$family}{$name_dinucl}*$count)+$tr;
    		}
    		if($tr == 0){$tr = 0;}
    		else{$tr = log(abs($tr));}
		$tr = sprintf("%.2f", $tr);
		push(@temp_array,"$i:$tr");    
	}
my $output = join(" ",@temp_array);
return($output);
}

sub features_miPred{
		my $sequences = $_[0];
		my $structures = $_[1];
		my @array32=();
		my @list1=("A","U","G","C");
		my @list2=("(((","((.","(.(","(..",".((",".(.","..(","...");
		my @count;
		for(my $i=0;$i<@list1;$i++){
    	for(my $j=0;$j<@list2;$j++){
    		$count[$i*8+$j] = 0;
    	} 
		}
		my @sequence= split(//,$sequences);
		my @structure= split(//,$structures);
		my $size = @sequence;
		for(my $k=1;$k<$size-1;$k++){
			for(my $i=0;$i<@list1;$i++){
				if($sequence[$k] eq $list1[$i]){
					my $triplet="$structure[$k-1]$structure[$k]$structure[$k+1]";
					for(my $j=0;$j<@list2;$j++){
						if($triplet eq $list2[$j]) {
							$count[$i*8+$j]++;
						}
					} 
				}
			}
		}
		for(my $i=0;$i<@list1;$i++){
			for(my $j=0;$j<@list2;$j++){
			if($size > 0){
				$count[$i*8+$j]=$count[$i*8+$j]/$size;
				push(@array32,sprintf("%.3f",$count[$i*8+$j]));
			} 
			}
		}
 return(@array32);
}
